%define api 5
%define major 5
%define oname qt5

%define module qtbase

# qt base components
%define qtbootstrapd %mklibname qt%{api}bootstrap -d
%define qtconcurrent %mklibname qt%{api}concurrent %{major}
%define qtconcurrentd %mklibname qt%{api}concurrent -d
%define qtcore %mklibname qt%{api}core %{major}
%define qtcored %mklibname qt%{api}core -d
%define qtdbus %mklibname qt%{api}dbus %{major}
%define qtdbusd %mklibname qt%{api}dbus -d
%define qtegldeviceintegration %mklibname qt%{api}egldeviceintegration %{major}
%define qtgui %mklibname qt%{api}gui %{major}
%define qtguid %mklibname qt%{api}gui -d
%define qtnetwork %mklibname qt%{api}network %{major}
%define qtnetworkd %mklibname qt%{api}network -d
%define qtopengl %mklibname qt%{api}opengl %{major}
%define qtopengld %mklibname qt%{api}opengl -d
%define qtprintsupport %mklibname qt%{api}printsupport %{major}
%define qtprintsupportd %mklibname qt%{api}printsupport -d
%define qtsql %mklibname qt%{api}sql %{major}
%define qtsqld %mklibname qt%{api}sql -d
%define qttest %mklibname qt%{api}test %{major}
%define qttestd %mklibname qt%{api}test -d
%define qtwidgets %mklibname qt%{api}widgets %{major}
%define qtwidgetsd %mklibname qt%{api}widgets -d
%define qtxcbqpa %mklibname qt%{api}xcbqpa %{major}
%define qtxml %mklibname qt%{api}xml %{major}
%define qtxmld %mklibname qt%{api}xml -d

%bcond_without directfb
# Requires qdoc5 and qt5-tools to build
%bcond_without docs

Summary:	Version 5 of the Qt toolkit (%{module} packages)
Name:		qt5-%{module}
Version:	5.6.1
Release:	2
License:	LGPLv3+
Group:		Development/KDE and Qt
Url:		http://qt-project.org/
Source0:	http://ftp.fau.de/qtproject/official_releases/qt/%(echo %{version} |cut -d. -f1-2)/%{version}/submodules/%{module}-opensource-src-%{version}.tar.xz
Source100:	%{name}.rpmlintrc
Patch5:		directfb-wm-p5.patch
# Revert https://codereview.qt-project.org/gitweb?p=qt%2Fqtbase.git;a=commit;h=d0cdc7ad1e2728caf363abf328b2ad81f2ed5a5b
Patch6:		QTBUG-51813-directfb-plugin-compilation.patch
# Fedora patches
Patch103:	qtbase-opensource-src-5.3.2-QTBUG-35459.patch
Patch200:	0001-xcb-Properly-interpret-data.l-0-field-of-XdndStatus-.patch
Patch201:	0011-XCB-Auto-detect-xcb-glx-also-with-xcb-qt.patch
Patch202:	0032-xcb-Fix-drop-of-text-uri-list-and-text-html.patch
Patch203:	0033-xcb-Fix-dropping-URL-on-Firefox-window.patch
Patch204:	0148-xcb-Disable-GLX-pbuffers-with-Chromium-in-VMs.patch
Patch205:	0155-xcb-Fix-transient-parent-and-Qt-Window-flag.patch

BuildRequires:	bison
BuildRequires:	flex
# Used for CPU feature detection in configure step
BuildRequires:	gdb
BuildRequires:	gperf
BuildRequires:	qt5-macros
BuildRequires:	cups-devel
BuildRequires:	jpeg-devel
BuildRequires:	pkgconfig(alsa)
BuildRequires:	pkgconfig(atspi-2)
%if %{with directfb}
# DirectFB platform plugin:
BuildRequires:	pkgconfig(directfb)
%endif
BuildRequires:	pkgconfig(egl)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
# Event loop
BuildRequires:	pkgconfig(glib-2.0)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glesv2)
BuildRequires:	pkgconfig(gstreamer-1.0)
BuildRequires:	pkgconfig(gstreamer-plugins-base-1.0)
# GTK theme
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(icu-uc)
BuildRequires:	pkgconfig(inputproto)
BuildRequires:	pkgconfig(libpci)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libpulse)
BuildRequires:	pkgconfig(libudev)
BuildRequires:	pkgconfig(sm)
BuildRequires:	pkgconfig(wayland-client)
BuildRequires:	pkgconfig(wayland-cursor)
BuildRequires:	pkgconfig(wayland-egl)
BuildRequires:	pkgconfig(wayland-scanner)
BuildRequires:	pkgconfig(wayland-server)
# For XCB platform plugin:
BuildRequires:	pkgconfig(xcb) >= 1.5
BuildRequires:	pkgconfig(xcb-icccm)
BuildRequires:	pkgconfig(xcb-image)
BuildRequires:	pkgconfig(xcb-keysyms)
BuildRequires:	pkgconfig(xcb-randr)
BuildRequires:	pkgconfig(xcb-render)
BuildRequires:	pkgconfig(xcb-renderutil)
BuildRequires:	pkgconfig(xcb-shape)
BuildRequires:	pkgconfig(xcb-xfixes)
BuildRequires:	pkgconfig(xcb-xinerama)
BuildRequires:	pkgconfig(xcb-xv)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xfixes)
BuildRequires:	pkgconfig(xi)
BuildRequires:	pkgconfig(xinerama)
BuildRequires:	pkgconfig(xkbcomp)
BuildRequires:	pkgconfig(xkbcommon) >= 0.4.1
BuildRequires:	pkgconfig(xkbcommon-x11) >= 0.4.1
BuildRequires:	pkgconfig(xkbfile)
BuildRequires:	pkgconfig(xrandr)
BuildRequires:	pkgconfig(xrender)
BuildRequires:	pkgconfig(xv)
BuildRequires:	pkgconfig(zlib)
%if %{with docs}
BuildRequires:	qdoc5
BuildRequires:	qt5-tools
%endif

%description
Version 5 of the Qt toolkit (%{module} packages).

#----------------------------------------------------------------------------

%package -n %{qtbootstrapd}
Summary:	Development files for version 5 of the Qt Bootstrap library
Group:		Development/KDE and Qt
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtbootstrapd}
Development files for version 5 of the Qt Bootstrap library.

%files -n %{qtbootstrapd}
%{_qt5_libdir}/libQt%{api}Bootstrap.a
%{_qt5_libdir}/libQt%{api}Bootstrap.prl
%{_qt5_prefix}/mkspecs/modules/qt_lib_bootstrap_private.pri

#----------------------------------------------------------------------------

%package -n %{qtconcurrent}
Summary:	Qt threading library
Group:		System/Libraries

%description -n %{qtconcurrent}
Qt threading library.

%files -n %{qtconcurrent}
%{_qt5_libdir}/libQt%{api}Concurrent.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Concurrent.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtconcurrentd}
Summary:	Development files for version 5 of the Qt Concurrent library
Group:		Development/KDE and Qt
Requires:	%{qtconcurrent} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6
# Was introduced by mistake
Obsoletes:	%{_lib}qt5concurrent5-devel < 5.6.0

%description -n %{qtconcurrentd}
Development files for version 5 of the Qt Concurrent library.

%files -n %{qtconcurrentd}
%{_qt5_includedir}/QtConcurrent
%{_qt5_libdir}/libQt%{api}Concurrent.so
%{_qt5_libdir}/libQt%{api}Concurrent.prl
%{_qt5_libdir}/cmake/Qt%{api}Concurrent
%{_qt5_libdir}/pkgconfig/Qt%{api}Concurrent.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Concurrent.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_concurrent.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_concurrent_private.pri

#----------------------------------------------------------------------------

%package -n %{qtcore}
Summary:	Qt Core library
Group:		System/Libraries
# Moved to external sources
Suggests:	qt5-qtcore-i18n
Obsoletes:	%{_lib}qt5v85 < 5.1.0-8
Obsoletes:	%{_lib}qt5v8_5 < 5.2.0

%description -n %{qtcore}
Qt Core library.

%files -n %{qtcore}
%{_qt5_libdir}/libQt%{api}Core.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Core.so.%{major}*
%endif
%dir %{_qt5_plugindir}

#----------------------------------------------------------------------------

%package -n %{qtcored}
Summary:	Development files for version 5 of the Qt Core library
Group:		Development/KDE and Qt
Requires:	%{qtcore} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6
Obsoletes:	%{_lib}qt5v8-devel < 5.2.0

%description -n %{qtcored}
Development files for version 5 of the Qt Core library.

%files -n %{qtcored}
%{_qt5_docdir}/global
%{_bindir}/moc-qt%{api}
%{_qt5_bindir}/moc
%{_bindir}/rcc-qt%{api}
%{_qt5_bindir}/rcc
%{_qt5_bindir}/syncqt.pl
%{_qt5_includedir}/QtCore
%{_qt5_libdir}/libQt%{api}Core.so
%{_qt5_libdir}/libQt%{api}Core.prl
%{_qt5_libdir}/cmake/Qt%{api}Core
%{_qt5_libdir}/cmake/Qt%{api}/Qt%{api}Config.cmake
%{_qt5_libdir}/cmake/Qt%{api}/Qt%{api}ConfigVersion.cmake
%{_qt5_libdir}/pkgconfig/Qt%{api}Core.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Core.pc
%endif
%dir %{_qt5_libdir}/cmake
%dir %{_qt5_libdir}/cmake/Qt%{api}
%dir %{_qt5_libdir}/pkgconfig
%{_qt5_prefix}/mkspecs/modules/qt_lib_core.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_core_private.pri

#----------------------------------------------------------------------------

%package -n %{qtdbus}
Summary:	Qt DBus connector library
Group:		System/Libraries

%description -n %{qtdbus}
Qt DBus connector library.

%files -n %{qtdbus}
%{_qt5_libdir}/libQt%{api}DBus.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}DBus.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtdbusd}
Summary:	Development files for version 5 of the Qt DBus library
Group:		Development/KDE and Qt
Requires:	%{qtdbus} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtdbusd}
Development files for version 5 of the Qt DBus library.

%files -n %{qtdbusd}
%{_qt5_bindir}/qdbuscpp2xml
%{_bindir}/qdbuscpp2xml-qt%{api}
%{_qt5_bindir}/qdbusxml2cpp
%{_bindir}/qdbusxml2cpp-qt%{api}
%{_qt5_includedir}/QtDBus
%{_qt5_libdir}/libQt%{api}DBus.so
%{_qt5_libdir}/libQt%{api}DBus.prl
%{_qt5_libdir}/cmake/Qt%{api}DBus
%{_qt5_libdir}/pkgconfig/Qt%{api}DBus.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}DBus.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_dbus.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_dbus_private.pri

#----------------------------------------------------------------------------

%package -n %{qtegldeviceintegration}
Summary:	Qt EGL Device Integration library
Group:		System/Libraries
Requires:	qt5-eglfs-integration-plugin-default = %{EVRD}
# Suggest all integration plugins
Suggests:	qt5-eglfs-integration-plugin-kms = %{EVRD}
Suggests:	qt5-eglfs-integration-plugin-x11 = %{EVRD}

%description -n %{qtegldeviceintegration}
Qt EGL Device Integration library.

%files -n %{qtegldeviceintegration}
%{_qt5_libdir}/libQt%{api}EglDeviceIntegration.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}EglDeviceIntegration.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtegldeviceintegration}-kms
Summary:	KMS support for the Qt EGL Device Integration library v5
Group:		System/Libraries
Requires:	%{qtegldeviceintegration} = %{EVRD}
Provides:	qt5-eglfs-integration-plugin = %{EVRD}
Provides:	qt5-eglfs-integration-plugin-kms = %{EVRD}
Obsoletes:	%{_lib}qt5gui5-kms < 5.5.0

%description -n %{qtegldeviceintegration}-kms
KMS support for the Qt EGL Device Integration library v5.

%files -n %{qtegldeviceintegration}-kms
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-kms-integration.so

#----------------------------------------------------------------------------

%package -n %{qtegldeviceintegration}-x11
Summary:	X11 support for the Qt EGL Device Integration library v5
Group:		System/Libraries
Requires:	%{qtegldeviceintegration} = %{EVRD}
Provides:	qt5-eglfs-integration-plugin = %{EVRD}
Provides:	qt5-eglfs-integration-plugin-default = %{EVRD}
Provides:	qt5-eglfs-integration-plugin-x11 = %{EVRD}

%description -n %{qtegldeviceintegration}-x11
X11 support for the Qt EGL Device Integration library v5.

%files -n %{qtegldeviceintegration}-x11
%{_qt5_plugindir}/egldeviceintegrations/libqeglfs-x11-integration.so

#----------------------------------------------------------------------------

%package -n %{qtgui}
Summary:	Qt GUI library
Group:		System/Libraries
Suggests:	qt5-imageformats-plugins
Suggests:	qt5-style-plugins
Requires:	qt5-output-driver = %{EVRD}
# Force it for now
Requires:	qt5-output-driver-default = %{EVRD}

%description -n %{qtgui}
Qt GUI library.

%files -n %{qtgui}
%{_qt5_libdir}/libQt%{api}Gui.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Gui.so.%{major}*
%endif
%{_qt5_plugindir}/imageformats
%dir %{_qt5_plugindir}/platforminputcontexts
%dir %{_qt5_plugindir}/platforms
%dir %{_qt5_plugindir}/platformthemes
%{_qt5_plugindir}/generic
%{_qt5_plugindir}/printsupport

#----------------------------------------------------------------------------

%package -n %{qtguid}
Summary:	Development files for version 5 of the Qt GUI library
Group:		Development/KDE and Qt
Requires:	%{qtgui} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6
# We need all the Platform plugins because the plugin related cmake files in
# %{_qt5_libdir}/cmake/Qt%{api}Gui cause fatal errors if the plugins aren't
# installed.
Requires:	%{qtgui}-directfb = %{EVRD}
Requires:	%{qtgui}-eglfs = %{EVRD}
%ifos linux
Requires:	%{qtgui}-linuxfb = %{EVRD}
%endif
Requires:	%{qtgui}-minimal = %{EVRD}
Requires:	%{qtgui}-minimalegl = %{EVRD}
Requires:	%{qtgui}-offscreen = %{EVRD}
Requires:	%{qtgui}-x11 = %{EVRD}
Requires:	%{oname}-platformtheme-gtk2 = %{EVRD}
Requires:	qt5-eglfs-integration-plugin-kms = %{EVRD}
Requires:	qt5-eglfs-integration-plugin-x11 = %{EVRD}
Requires:	qt5-xcb-integration-plugin-egl = %{EVRD}
Requires:	qt5-xcb-integration-plugin-glx = %{EVRD}

%description -n %{qtguid}
Development files for version 5 of the Qt GUI library.

%files -n %{qtguid}
%{_qt5_bindir}/uic
%{_bindir}/uic-qt%{api}
%{_qt5_includedir}/QtGui
%{_qt5_includedir}/QtPlatformHeaders
%{_qt5_includedir}/QtPlatformSupport
%{_qt5_libdir}/libQt%{api}Gui.so
%{_qt5_libdir}/libQt%{api}Gui.prl
%{_qt5_libdir}/libQt%{api}PlatformSupport.a
%{_qt5_libdir}/libQt%{api}PlatformSupport.prl
%{_qt5_libdir}/cmake/Qt%{api}Gui
%{_qt5_libdir}/pkgconfig/Qt%{api}Gui.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Gui.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_gui.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_gui_private.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_platformsupport_private.pri
# Here until there are individual development packages for them
%{_qt5_prefix}/mkspecs/modules/qt_lib_eglfs_device_lib_private.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_xcb_qpa_lib_private.pri

#----------------------------------------------------------------------------

%package -n %{qtgui}-directfb
Summary:	DirectFB output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-directfb = %{EVRD}

%description -n %{qtgui}-directfb
DirectFB output driver for Qt GUI v5.

%files -n %{qtgui}-directfb
%{_qt5_plugindir}/platforms/libqdirectfb.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-eglfs
Summary:	EGL fullscreen output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-eglfs = %{EVRD}

%description -n %{qtgui}-eglfs
EGL fullscreen output driver for Qt GUI v5.

%files -n %{qtgui}-eglfs
%{_qt5_plugindir}/platforms/libqeglfs.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-linuxfb
Summary:	Linux Framebuffer output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-linuxfb = %{EVRD}

%description -n %{qtgui}-linuxfb
Linux Framebuffer output driver for Qt GUI v5.

%files -n %{qtgui}-linuxfb
%{_qt5_plugindir}/platforms/libqlinuxfb.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-minimal
Summary:	Minimal (Framebuffer based) output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-minimal = %{EVRD}

%description -n %{qtgui}-minimal
Minimal (Framebuffer based) output driver for Qt GUI v5.

%files -n %{qtgui}-minimal
%{_qt5_plugindir}/platforms/libqminimal.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-minimalegl
Summary:	Minimalistic EGL output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-minimalegl = %{EVRD}

%description -n %{qtgui}-minimalegl
Minimalistic EGL output driver for Qt GUI v5.

%files -n %{qtgui}-minimalegl
%{_qt5_plugindir}/platforms/libqminimalegl.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-offscreen
Summary:	Offscreen output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-offscreen = %{EVRD}

%description -n %{qtgui}-offscreen
Minimal (framebuffer-based) output driver for Qt GUI v5.

%files -n %{qtgui}-offscreen
%{_qt5_plugindir}/platforms/libqoffscreen.so

#----------------------------------------------------------------------------

%package -n %{qtgui}-x11
Summary:	X11 output driver for Qt GUI v5
Group:		System/Libraries
Requires:	%{qtgui} = %{EVRD}
Provides:	qt5-output-driver = %{EVRD}
Provides:	qt5-output-driver-default = %{EVRD}
Provides:	qt5-output-driver-x11 = %{EVRD}

%description -n %{qtgui}-x11
X11 output driver for Qt GUI v5.

%files -n %{qtgui}-x11
%{_qt5_plugindir}/platforms/libqxcb.so
%{_qt5_plugindir}/platforminputcontexts/libibusplatforminputcontextplugin.so
%{_qt5_plugindir}/platforminputcontexts/libcomposeplatforminputcontextplugin.so

#----------------------------------------------------------------------------

%package -n %{qtnetwork}
Summary:	Qt Networking library
Group:		System/Libraries

%description -n %{qtnetwork}
Qt Networking library.

%files -n %{qtnetwork}
%{_qt5_libdir}/libQt%{api}Network.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Network.so.%{major}*
%endif
%{_qt5_plugindir}/bearer

#----------------------------------------------------------------------------

%package -n %{qtnetworkd}
Summary:	Development files for version 5 of the Qt Network library
Group:		Development/KDE and Qt
Requires:	%{qtnetwork} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtnetworkd}
Development files for version 5 of the Qt Network library.

%files -n %{qtnetworkd}
%{_qt5_includedir}/QtNetwork
%{_qt5_libdir}/libQt%{api}Network.so
%{_qt5_libdir}/libQt%{api}Network.prl
%{_qt5_libdir}/cmake/Qt%{api}Network
%{_qt5_libdir}/pkgconfig/Qt%{api}Network.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Network.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_network.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_network_private.pri

#----------------------------------------------------------------------------

%package -n %{qtopengl}
Summary:	Qt OpenGL (3D Graphics) library
Group:		System/Libraries

%description -n %{qtopengl}
Qt OpenGL (3D Graphics) library.

%files -n %{qtopengl}
%{_qt5_libdir}/libQt%{api}OpenGL.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}OpenGL.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtopengld}
Summary:	Development files for version 5 of the Qt OpenGL library
Group:		Development/KDE and Qt
Requires:	%{qtopengl} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtopengld}
Development files for version 5 of the Qt OpenGL library.

%files -n %{qtopengld}
%{_qt5_includedir}/QtOpenGL
%{_qt5_includedir}/QtOpenGLExtensions
%{_qt5_libdir}/libQt%{api}OpenGL.so
%{_qt5_libdir}/libQt%{api}OpenGL.prl
%{_qt5_libdir}/libQt%{api}OpenGLExtensions.a
%{_qt5_libdir}/libQt%{api}OpenGLExtensions.prl
%{_qt5_libdir}/cmake/Qt%{api}OpenGL
%{_qt5_libdir}/cmake/Qt%{api}OpenGLExtensions
%{_qt5_libdir}/pkgconfig/Qt%{api}OpenGL.pc
%{_qt5_libdir}/pkgconfig/Qt%{api}OpenGLExtensions.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}OpenGL.pc
%{_libdir}/pkgconfig/Qt%{api}OpenGLExtensions.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_opengl.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_opengl_private.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_openglextensions.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_openglextensions_private.pri

#----------------------------------------------------------------------------

%package -n %{qtprintsupport}
Summary:	Qt printing library
Group:		System/Libraries

%description -n %{qtprintsupport}
Qt printing library.

%files -n %{qtprintsupport}
%{_qt5_libdir}/libQt%{api}PrintSupport.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}PrintSupport.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtprintsupportd}
Summary:	Development files for version 5 of the Qt PrintSupport library
Group:		Development/KDE and Qt
Requires:	%{qtprintsupport} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtprintsupportd}
Development files for version 5 of the Qt PrintSupport library.

%files -n %{qtprintsupportd}
%{_qt5_includedir}/QtPrintSupport
%{_qt5_libdir}/libQt%{api}PrintSupport.so
%{_qt5_libdir}/libQt%{api}PrintSupport.prl
%{_qt5_libdir}/cmake/Qt%{api}PrintSupport
%{_qt5_libdir}/pkgconfig/Qt%{api}PrintSupport.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}PrintSupport.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_printsupport.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_printsupport_private.pri

#----------------------------------------------------------------------------

%package -n %{qtsql}
Summary:	Qt SQL library
Group:		System/Libraries

%description -n %{qtsql}
Qt SQL library.

%files -n %{qtsql}
%{_qt5_libdir}/libQt%{api}Sql.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Sql.so.%{major}*
%endif
%dir %{_qt5_plugindir}/sqldrivers

#----------------------------------------------------------------------------

%package -n %{qtsqld}
Summary:	Development files for version 5 of the Qt SQL library
Group:		Development/KDE and Qt
Requires:	%{qtsql} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6
# We need all the QtSql plugins because the plugin related cmake files in
# %{_qt5_libdir}/cmake/Qt%{api}Sql cause fatal errors if the plugins aren't
# installed.
Requires:	%{qtsql}-mysql = %{EVRD}
Requires:	%{qtsql}-odbc = %{EVRD}
Requires:	%{qtsql}-postgresql = %{EVRD}
Requires:	%{qtsql}-sqlite = %{EVRD}

%description -n %{qtsqld}
Development files for version 5 of the Qt SQL library.

%files -n %{qtsqld}
%{_qt5_includedir}/QtSql
%{_qt5_libdir}/libQt%{api}Sql.so
%{_qt5_libdir}/libQt%{api}Sql.prl
%{_qt5_libdir}/cmake/Qt%{api}Sql
%{_qt5_libdir}/pkgconfig/Qt%{api}Sql.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Sql.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_sql.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_sql_private.pri

#----------------------------------------------------------------------------

%package -n %{qtsql}-mysql
Summary:	MySQL support for the Qt SQL library v5
Group:		System/Libraries
Requires:	%{qtsql} = %{EVRD}
Provides:	%{oname}-database-plugin-mysql = %{EVRD}
BuildRequires:	mysql-devel

%description -n %{qtsql}-mysql
MySQL support for the Qt SQL library v5.

%files -n %{qtsql}-mysql
%{_qt5_plugindir}/sqldrivers/libqsqlmysql.so

#----------------------------------------------------------------------------

%package -n %{qtsql}-odbc
Summary:	ODBC support for the Qt SQL library v5
Group:		System/Libraries
Requires:	%{qtsql} = %{EVRD}
Provides:	%{oname}-database-plugin-odbc = %{EVRD}
BuildRequires:	pkgconfig(libiodbc)

%description -n %{qtsql}-odbc
ODBC support for the Qt SQL library v5.

%files -n %{qtsql}-odbc
%{_qt5_plugindir}/sqldrivers/libqsqlodbc.so

#----------------------------------------------------------------------------

%package -n %{qtsql}-postgresql
Summary:	PostgreSQL support for the Qt SQL library v5
Group:		System/Libraries
Requires:	%{qtsql} = %{EVRD}
Provides:	%{oname}-database-plugin-postgresql = %{EVRD}
BuildRequires:	postgresql-devel >= 9.0

%description -n %{qtsql}-postgresql
PostgreSQL support for the Qt SQL library v5.

%files -n %{qtsql}-postgresql
%{_qt5_plugindir}/sqldrivers/libqsqlpsql.so

#----------------------------------------------------------------------------

%package -n %{qtsql}-sqlite
Summary:	SQLite 3.x support for the Qt SQL library v5
Group:		System/Libraries
Requires:	%{qtsql} = %{EVRD}
Provides:	%{oname}-database-plugin-sqlite = %{EVRD}
BuildRequires:	pkgconfig(sqlite3)

%description -n %{qtsql}-sqlite
SQLite 3.x support for the Qt SQL library v5.

%files -n %{qtsql}-sqlite
%{_qt5_plugindir}/sqldrivers/libqsqlite.so

#----------------------------------------------------------------------------

%package -n %{qttest}
Summary:	Qt unit test library
Group:		System/Libraries

%description -n %{qttest}
Qt unit test library.

%files -n %{qttest}
%{_qt5_libdir}/libQt%{api}Test.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Test.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qttestd}
Summary:	Development files for version 5 of the Qt Test library
Group:		Development/KDE and Qt
Requires:	%{qttest} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qttestd}
Development files for version 5 of the Qt Test library.

%files -n %{qttestd}
%{_qt5_includedir}/QtTest
%{_qt5_libdir}/libQt%{api}Test.so
%{_qt5_libdir}/libQt%{api}Test.prl
%{_qt5_libdir}/cmake/Qt%{api}Test
%{_qt5_libdir}/pkgconfig/Qt%{api}Test.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Test.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_testlib.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_testlib_private.pri

#----------------------------------------------------------------------------

%package -n %{qtwidgets}
Summary:	Qt Widget library
Group:		System/Libraries

%description -n %{qtwidgets}
Qt Widget library.

%files -n %{qtwidgets}
%{_qt5_libdir}/libQt%{api}Widgets.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Widgets.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtwidgetsd}
Summary:	Development files for version 5 of the Qt Widgets library
Group:		Development/KDE and Qt
Requires:	%{qtwidgets} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtwidgetsd}
Development files for version 5 of the Qt Widgets library.

%files -n %{qtwidgetsd}
%{_qt5_includedir}/QtWidgets
%{_qt5_libdir}/libQt%{api}Widgets.so
%{_qt5_libdir}/libQt%{api}Widgets.prl
%{_qt5_libdir}/cmake/Qt%{api}Widgets
%{_qt5_libdir}/pkgconfig/Qt%{api}Widgets.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Widgets.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_widgets.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_widgets_private.pri

#----------------------------------------------------------------------------

%package -n %{qtxcbqpa}
Summary:	Qt XCB QPA library
Group:		System/Libraries
Requires:	qt5-xcb-integration-plugin-default = %{EVRD}
# Suggest all integration plugins
Suggests:	qt5-xcb-integration-plugin-egl = %{EVRD}
Suggests:	qt5-xcb-integration-plugin-glx = %{EVRD}

%description -n %{qtxcbqpa}
Qt XCB QPA library.

%files -n %{qtxcbqpa}
%{_qt5_libdir}/libQt%{api}XcbQpa.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}XcbQpa.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtxcbqpa}-egl
Summary:	EGL support for the Qt XCB QPA library v5
Group:		System/Libraries
Requires:	%{qtxcbqpa} = %{EVRD}
Provides:	qt5-xcb-integration-plugin = %{EVRD}
Provides:	qt5-xcb-integration-plugin-egl = %{EVRD}

%description -n %{qtxcbqpa}-egl
EGL support for the Qt XCB QPA library v5.

%files -n %{qtxcbqpa}-egl
%{_qt5_plugindir}/xcbglintegrations/libqxcb-egl-integration.so

#----------------------------------------------------------------------------

%package -n %{qtxcbqpa}-glx
Summary:	GLX support for the Qt XCB QPA library v5
Group:		System/Libraries
Requires:	%{qtxcbqpa} = %{EVRD}
Provides:	qt5-xcb-integration-plugin = %{EVRD}
Provides:	qt5-xcb-integration-plugin-default = %{EVRD}
Provides:	qt5-xcb-integration-plugin-glx = %{EVRD}

%description -n %{qtxcbqpa}-glx
GLX support for the Qt XCB QPA library v5.

%files -n %{qtxcbqpa}-glx
%{_qt5_plugindir}/xcbglintegrations/libqxcb-glx-integration.so

#----------------------------------------------------------------------------

%package -n %{qtxml}
Summary:	Qt XML library
Group:		System/Libraries

%description -n %{qtxml}
Qt XML library.

%files -n %{qtxml}
%{_qt5_libdir}/libQt%{api}Xml.so.%{major}*
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/libQt%{api}Xml.so.%{major}*
%endif

#----------------------------------------------------------------------------

%package -n %{qtxmld}
Summary:	Development files for version 5 of the Qt XML library
Group:		Development/KDE and Qt
Requires:	%{qtxml} = %{EVRD}
Requires:	qmake%{api}
Conflicts:	qmake5 < 5.6.0-6

%description -n %{qtxmld}
Development files for version 5 of the Qt XML library.

%files -n %{qtxmld}
%{_qt5_includedir}/QtXml
%{_qt5_libdir}/libQt%{api}Xml.so
%{_qt5_libdir}/libQt%{api}Xml.prl
%{_qt5_libdir}/cmake/Qt%{api}Xml
%{_qt5_libdir}/pkgconfig/Qt%{api}Xml.pc
%if "%{_qt5_libdir}" != "%{_libdir}"
%{_libdir}/pkgconfig/Qt%{api}Xml.pc
%endif
%{_qt5_prefix}/mkspecs/modules/qt_lib_xml.pri
%{_qt5_prefix}/mkspecs/modules/qt_lib_xml_private.pri

#----------------------------------------------------------------------------

%package -n %{oname}-devel
Summary:	Meta-package for installing all Qt 5 development files
Group:		Development/KDE and Qt
Requires:	%{qtbootstrapd} = %{EVRD}
Requires:	%{qtconcurrentd} = %{EVRD}
Requires:	%{qtcored} = %{EVRD}
Requires:	%{qtdbusd} = %{EVRD}
Requires:	%{qtguid} = %{EVRD}
Requires:	%{qtnetworkd} = %{EVRD}
Requires:	%{qtopengld} = %{EVRD}
Requires:	%{qtprintsupportd} = %{EVRD}
Requires:	%{qtsqld} = %{EVRD}
Requires:	%{qttestd} = %{EVRD}
Requires:	%{qtwidgetsd} = %{EVRD}
Requires:	%{qtxmld} = %{EVRD}
Requires:	qmake%{api} = %{EVRD}
Requires:	qlalr%{api} = %{EVRD}

%description -n %{oname}-devel
Meta-package for installing all Qt 5 development files.

%files -n %{oname}-devel
# Intentionally empty, we just pull in dependencies

#----------------------------------------------------------------------------
# qt tools etc
#----------------------------------------------------------------------------

%if %{with docs}
%package doc
Summary:	Qt QCH documentation for %{name}
Group:		Documentation
Conflicts:	qt5-doc < 5.6.0
BuildArch:	noarch

%description doc
Qt QCH documentation for %{name}.

%files doc
%{_qt5_docdir}/qmake.qch
%{_qt5_docdir}/qtconcurrent.qch
%{_qt5_docdir}/qtcore.qch
%{_qt5_docdir}/qtdbus.qch
%{_qt5_docdir}/qtgui.qch
%{_qt5_docdir}/qtnetwork.qch
%{_qt5_docdir}/qtopengl.qch
%{_qt5_docdir}/qtplatformheaders.qch
%{_qt5_docdir}/qtprintsupport.qch
%{_qt5_docdir}/qtsql.qch
%{_qt5_docdir}/qttestlib.qch
%{_qt5_docdir}/qtwidgets.qch
%{_qt5_docdir}/qtxml.qch
%endif

#----------------------------------------------------------------------------

%package examples
Summary:	Example applications for %{name}
Group:		Development/KDE and Qt
Conflicts:	qt5-examples < 5.6.0

%description examples
Example applications for %{name}.

%files examples
%{_qt5_exampledir}/corelib/
%{_qt5_exampledir}/dbus/
%{_qt5_exampledir}/gui/
%{_qt5_exampledir}/network/
%{_qt5_exampledir}/opengl/
%{_qt5_exampledir}/qpa/
%{_qt5_exampledir}/qtconcurrent/
%{_qt5_exampledir}/qtestlib/
%{_qt5_exampledir}/sql/
%{_qt5_exampledir}/touch/
%{_qt5_exampledir}/widgets/
%{_qt5_exampledir}/xml/
%{_qt5_exampledir}/examples.pro
%{_qt5_exampledir}/README

#----------------------------------------------------------------------------

%package -n %{oname}-platformtheme-gtk2
Summary:	GTK 2.x platform theme for Qt 5
Group:		Graphical desktop/KDE
Requires:	%{qtgui} = %{EVRD}
BuildRequires:	pkgconfig(gtk+-x11-2.0)

%description -n %{oname}-platformtheme-gtk2
GTK 2.x platform theme for Qt 5. This plugin allows Qt to render
controls using GTK 2.x themes - making it integrate better with GTK
based desktops.

%files -n %{oname}-platformtheme-gtk2
%{_qt5_plugindir}/platformthemes/libqgtk2.so

#----------------------------------------------------------------------------

%package -n qmake%{api}
Summary:	Makefile generation system for Qt 5
Group:		Development/KDE and Qt
Requires:	qt5-macros

%description -n qmake%{api}
Makefile generation system for Qt 5.

%files -n qmake%{api}
%{_bindir}/qmake-qt%{api}
%{_qt5_bindir}/qmake
%{_qt5_prefix}/mkspecs/
%exclude %{_qt5_prefix}/mkspecs/modules/

#----------------------------------------------------------------------------

%package -n qlalr%{api}
Summary:	Qt LALR parser generator
Group:		Development/KDE and Qt
Provides:	qlalr = %{EVRD}

%description -n qlalr%{api}
Qt LALR parser generator.

%files -n qlalr%{api}
%{_qt5_bindir}/qlalr

#----------------------------------------------------------------------------

%prep
%setup -qn %{module}-opensource-src-%{version}

%patch5 -p2 -b .dfbwm~
%patch6 -p1

%patch103 -p1
%patch200 -p1
%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1

# respect cflags
sed -i -e '/^CPPFLAGS\s*=/ s/-g //' qmake/Makefile.unix

sed -i -e "s|^\(QMAKE_LFLAGS_RELEASE.*\)|\1 %{ldflags}|" mkspecs/common/g++-unix.conf

sed -i -e "s|-O2|%{optflags}|g" mkspecs/common/gcc-base.conf
sed -i -e "s|-O3|%{optflags}|g" mkspecs/common/gcc-base.conf

%build
./configure \
	-prefix %{_qt5_prefix} \
	-bindir %{_qt5_bindir} \
	-libdir %{_qt5_libdir} \
	-datadir %{_qt5_datadir} \
	-docdir %{_qt5_docdir} \
	-headerdir %{_qt5_includedir} \
	-plugindir %{_qt5_plugindir} \
	-importdir %{_qt5_importdir} \
	-translationdir %{_qt5_translationsdir} \
	-sysconfdir %{_qt5_sysconfdir} \
	-examplesdir %{_qt5_exampledir} \
	-testsdir %{_qt5_testsdir} \
%ifarch x86_64
	-platform linux-g++-64 \
%endif
%ifarch %{ix86}
	-platform linux-g++-32 \
%endif
%ifarch %{arm}
	-platform linux-g++ \
%endif
	-confirm-license \
	-release \
	-opensource \
	-shared \
	-c++11 \
	-no-use-gold-linker \
	-reduce-relocations \
	-no-separate-debug-info \
	-no-strip \
	-largefile \
	-no-sql-db2 \
	-no-sql-ibase \
	-plugin-sql-mysql \
	-no-sql-oci \
	-plugin-sql-odbc \
	-plugin-sql-psql \
	-plugin-sql-sqlite \
	-no-sql-sqlite2 \
	-no-sql-tds \
	-system-libpng \
	-system-libjpeg \
	-system-pcre \
	-system-proxies \
	-system-sqlite \
	-system-xcb \
	-system-zlib \
	-openssl-linked \
	-optimized-qmake \
	-no-nis \
	-cups \
	-gstreamer \
	-iconv \
	-icu \
	-pch \
	-dbus-linked \
	-xcb \
%if %{with directfb}
	-directfb \
%endif
	-qpa xcb \
	-accessibility \
	-fontconfig \
	-eglfs \
	-gnumake \
	-pkg-config \
	-kms \
	-sm \
	-xinerama \
	-xshape \
	-xvideo \
	-xsync \
	-xinput2 \
	-xcursor \
	-xfixes \
	-xrandr \
	-xrender \
	-xkb \
	-opengl \
	-glib \
%if "%{_qt5_libdir}" == "%{_libdir}"
	-no-rpath \
%endif
	-I %{_includedir}/iodbc \
	-I %{_includedir}/mysql

%make STRIP=true

%if %{with docs}
%make docs
%endif

%install
make install STRIP=true INSTALL_ROOT=%{buildroot}

%if %{with docs}
make install_qch_docs INSTALL_ROOT=%{buildroot}
%endif

# Installed, but not useful
rm -f %{buildroot}%{_qt5_bindir}/fixqt4headers.pl
# Probably not useful outside of Qt source tree?
rm -f %{buildroot}%{_qt5_bindir}/qtmodule-configtests
# Let's not ship -devel files for private libraries... At least not until
# applications teach us otherwise
rm -f %{buildroot}%{_qt5_libdir}/libQt%{api}EglDeviceIntegration.so %{buildroot}%{_qt5_libdir}/libQt%{api}EglDeviceIntegration.prl %{buildroot}%{_qt5_libdir}/pkgconfig/Qt%{api}EglDeviceIntegration.pc
rm -f %{buildroot}%{_qt5_libdir}/libQt%{api}XcbQpa.so %{buildroot}%{_qt5_libdir}/libQt%{api}XcbQpa.prl %{buildroot}%{_qt5_libdir}/pkgconfig/Qt%{api}XcbQpa.pc
# Let's make life easier for packagers
mkdir -p %{buildroot}%{_bindir}
for i in qmake moc uic rcc qdbuscpp2xml qdbusxml2cpp; do
	ln -s ../%{_lib}/qt%{api}/bin/$i %{buildroot}%{_bindir}/$i-qt%{api}
done

%if "%{_qt5_libdir}" != "%{_libdir}"
pushd %{buildroot}%{_libdir}
ln -s ../%{_lib}/qt%{api}/%{_lib}/*.so.* .
mkdir pkgconfig
cd pkgconfig
ln -s ../../%{_lib}/qt%{api}/%{_lib}/pkgconfig/*.pc .
popd
%endif

# Fix some wrong permissions
find %{buildroot} -type f -perm -0755 -name "*.png" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.svg" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.jpg" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.xml" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.xsl" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.php" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.html" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.js" |xargs --no-run-if-empty chmod 0644
find %{buildroot} -type f -perm -0755 -name "*.plist.app" |xargs --no-run-if-empty chmod 0644

# Workaround for
# *** ERROR: same build ID in nonidentical files!
#        /usr/lib/qt5/bin/qdbuscpp2xml
#   and  /usr/lib/qt5/bin/moc
# ...
# while generating debug info
find %{buildroot} -type f -perm -0755 |grep -vE '\.(so|qml|sh|pl|ttf|eot|woff)' |xargs %__strip --strip-unneeded

# QMAKE_PRL_BUILD_DIR = /builddir/build/BUILD/qt-everywhere-opensource-src-5.4.0-beta/qtwayland/src/client
## .prl/.la file love
# nuke .prl reference(s) to %%buildroot, excessive (.la-like) libs
pushd %{buildroot}%{_qt5_libdir}
for prl_file in libQt5*.prl ; do
  sed -i -e "/^QMAKE_PRL_BUILD_DIR/d" ${prl_file}
  if [ -f "$(basename ${prl_file} .prl).so" ]; then
    rm -fv "$(basename ${prl_file} .prl).la"
    sed -i -e "/^QMAKE_PRL_LIBS/d" ${prl_file}
  fi
done
popd

%changelog

* Thu Jun 16 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 5.6.1-2
- (dd6bdbf) Add various bugfix patches from Fedora


